{*******************************************************}
{                                                       }
{       DX81Reg:registrace komponenty TMediaSource      }
{                                                       }
{       Vyrobeno  (c) 2003, Z6 (zdeno6@seznam.cz)       }
{                                                       }
{*******************************************************}
unit DX81Reg;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Graphics,Forms,
  StdCtrls,MMSystem,DesignEditors,MediaSource,ZipEditForm,Dialogs,
  SelectZIP,DesignIntf;

type

  TMediaPathProperty = class(TClassProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
    procedure SetValue(const Value: string); override;
    procedure Edit;override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TMediaPath), TSourceItem, 'Path',
    TMediaPathProperty);
  RegisterComponents('Z6', [TMediaSource]);
end;

{ TMediaPathProperty }
procedure TMediaPathProperty.Edit;
var p:TSourceItem;
    form:TMainForm;
    selz:TSelZIP;
    mem:TMemoryStream;
    od:TOpenDialog;
begin
  p:=GetComponent(0) as TSourceItem;
  Case p.SourceType of
    stResource:
      begin
        if p.ZIP[0]=nil then
          raise Exception.Create('ZIP je nil');
        if (p.ZIP[0].ZipSource=nil) then exit;
        form:=TMainForm.Create(nil);
        try
          p.ZIP[0].ZipSource.Position:=0;
          form.Source:=p.ZIP[0].ZipSource;
          form.ShowModal;
          if form.Modalresult = IDYES then begin
            mem:=TMemoryStream.Create;
            try
              form.Z.SaveZIPToStream(mem);
              p.ZIP[0].ZIpSource.Size:=mem.Size;
              Move(mem.Memory^,TMemoryStream(p.ZIP[0].ZIpSource).Memory^,mem.Size);
            finally
              mem.Free;
            end;
          end;
        finally
          form.Free;
        end;
      end;
    stFile:
      begin
        // pro typ stFile vybereme adres, ze kterho se bude erpat
        od:=TOpenDialog.Create(nil);
        try
          od.Options:=[ofHideReadOnly,ofNoChangeDir,ofNoValidate,ofEnableSizing];
          od.InitialDir:=GetValue;
          od.FileName:='*.*';
          if od.Execute then
            SetValue(ExtractFilePath(od.FileName));
        finally
          od.Free;
        end;
      end;
    stZIP:
      begin
        // pro zip zobrazme seznam soubor s monost jejich
        // editace nebo zmny cesty
        selz:=TSelZIP.Create(nil);
        if ExtractFilePath(GetValue) = '' then
          SetValue(GetCurrentDir+'\'+GetValue);
        selz.PathName:=GetValue;
        try
          selz.ShowModal;
          SetValue(selz.PathName);
          SetCurrentDir(ExtractFilePath(GetValue));
        finally
          selz.Free;
        end;
      end;
  end;
  Modified;
end;

function TMediaPathProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes  + [paDialog] - [paReadOnly] - [paSubProperties];
end;

function TMediaPathProperty.GetValue: string;
begin
  Result:=GetStrValue;
end;

procedure TMediaPathProperty.SetValue(const Value: string);
begin
  SetStrValue(Value);
end;

end.
