{*******************************************************}
{                                                       }
{       HexDump:Hexadecimln editor 2.0                }
{                                                       }
{       Vyrobeno  (c) 2001, Z6 (zdeno6@seznam.cz)       }
{                                                       }
{*******************************************************}
unit HexDump;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,ExtCtrls,Clipbrd;

const
  MAXDIGITS = 24;
  MAXSCROLLLINES = 32767;

type TClipFormat = (cfText,cfMemory);
var CF_MEMORY:Word;	//ClipBoard format pro pamov blok

type
   TCur = class
   private
      Fpoint:TPoint;
      FHandle:HWND;  // handle okna, kam se vykresluje
      FHeight:integer;
      FVisible:boolean;
      procedure Update;  // nastav kurzor podle FHeight,FVisible a FPoint;
      procedure SetVisible(Vis:boolean);
      procedure SetPoint(Pnt:TPoint);
      procedure SetHeight(Height:integer);
    public
      constructor Create(Han:integer);
      destructor Destroy;override;
      property Height:integer read FHeight write SetHeight;
      property Point:TPoint read FPoint write SetPoint;
      property Visible:boolean read FVisible write SetVisible;
    end;

  TClipB = class (TClipBoard)
      private
      FcbBegin:integer;		// aktuln adresa zatku bloku
      FcbEnd:integer;			// aktuln adresa konce bloku
      FPosition:integer;	// posledn poloha kurzoru
      FClipFormat:TClipFormat;	// text nebo vlastn formt Memory
      procedure SetBuffer(Format: Word; var Buffer; Size: Integer);
      function GetSelected:boolean;
      function GetSizeOfData:integer;
    public
      property SizeOfData:integer read GetSizeOfData; // velikost dat ve schrnce (pouze CF_TEXT a CF_MEMORY)
      property cbBegin:integer read FcbBegin write FcbBegin;
      property cbEnd:integer read FcbEnd write FcbEnd;
      property Selected:boolean read GetSelected;
      function SetPosition(Position:Integer;Select:boolean):boolean; // pesune kurzor a oet oznaen bloku
      function UnSelect:boolean;
      procedure CopyToClip(OffSet:pointer);
      procedure PasteFromClip(Offset:pointer);
      constructor Create;
    published
      property ClipBoardFormat:TClipFormat read FClipFormat write FClipFormat;
    end;

  THexStr = array[0..2] of Char;
  THexStrArray = array[0..MAXDIGITS-1] of THexStr;
  TOpType = (otWrite,otInsert,otDelete);
  TStoreUndoEvent = procedure(Sender:TObject;optype:TOpType;Position:Cardinal;Size:Cardinal) of object;
  TPositionEvent = procedure(Sender:TObject;NewPosition:integer;var Accept:boolean) of object;

  THexDump = class(TCustomControl)
  private
    FMemory:TMemoryStream;
    FAddressOffSet:Cardinal;
    FCanEdit:boolean;
    FTopLine: Integer;
    FCurrentLine: Integer;
    FVisibleLines: Integer;
    FLineCount: Integer;
    FBytesPerLine: Integer;
    FItemHeight: Integer;
    FItemWidth: Integer;
    FFileColors: array[0..5] of TColor;
    FShowCharacters: Boolean;
    FShowAddress: Boolean;
    FBorder: TBorderStyle;
    FHexData: THexStrArray;
    FLineAddr: array[0..15] of char;
    FCharData: array[0..MAXDIGITS] of char;
    FCursor:TCur;				// objekt, zajiujc kurzor
    FPosition:integer;	// ukazatel na msto,na kter ukazuje kurzor
    FHexEdit:boolean;	// Kurzor je v prostoru hexa slic
    FHalf:boolean;		// Kurzor je v polovin hexa sla  nap.: A|1
    FClipBoard:TClipB;	// pstup ke schrnce
    FAdjustWidth:byte; 	// piteno k ce znaku
    FAdjustHeight:byte; // piteno k vce znaku
    FChange:TNotifyEvent; // udlost zmny obsahu
    FChangePos:TPositionEvent; // zmna pozice
    FStoreUndo:TStoreUndoEvent; // zapis undo informaci
    procedure WriteByte(B:Byte);    							// Zpis do pamti
    procedure CalcPaintParams;
    procedure CalcCurParams;                      // Vpoet pozice kurzoru
    procedure SetTopLine(Value: Integer);
    procedure SetCurrentLine(Value: Integer);
    procedure SetHexEdit(Hex:boolean);						// pepnn msta editace
    procedure SetFileColor(Index: Integer; Value: TColor);
    function GetFileColor(Index: Integer): TColor;
    procedure SetShowCharacters(Value: Boolean);
    procedure SetShowAddress(Value: Boolean);
    procedure SetBorder(Value: TBorderStyle);
    function GetAddress:pointer;								// Zskn ukazatele do pamti
    procedure SetDataSize(Value: Integer);
    function GetDataSize:integer;
    procedure AdjustScrollBars;
    function LineAddr(Index: Integer): PChar;
    procedure SetLineData(Index: Integer);
    procedure SetChars(Index: Integer);
    function GetPositionAt(X:integer;Y:integer):int64;	//zsk adresu pozice z bodu
    procedure SelectedTextOut(Line:integer;R:TRect;Writehex:boolean;BorderColor:TColor);
    procedure PaintLine(Line:integer;CanHigh:boolean);
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED; // !!! bylo CM_FONTCHANGED
    procedure CMEnter(var Message: TCMGotFocus); message CM_ENTER;
    procedure CMExit(var Message: TCMLostFocus); message CM_EXIT;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure SetAddressOffSet(Offset:Cardinal);
  protected
    procedure CreateWindowHandle(const Params: TCreateParams); override;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure Paint; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key:Char);override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer);override;
    procedure DragOver(Source: TObject; X, Y: Integer; State: TDragState;var Accept: Boolean);override;
  public
    Translate:array[0..255] of char;   // pevodn tabulka
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property CurrentLine: Integer read FCurrentLine write SetCurrentLine;
    property Position: Integer read FPosition;
    property HexEdit:boolean read FHexEdit write SetHexEdit;
    property Address: Pointer read GetAddress;
    property AddressOffSet: Cardinal read FAddressOffSet write SetAddressOffSet;
    property DataSize: integer read GetDataSize write SetDataSize;
    procedure AssignStream(Stream:TStream);
    procedure AssignToStream(Stream:TStream);
    procedure Delete(Pos:integer;Size:integer);		// smazn bloku
    procedure Insert(Pos:integer;Size:integer);		// vloen bloku
    procedure SetSelectPosition(Pos:integer;CanSelect:boolean);
  published
    property CanEdit:boolean read FCanEdit write FCanEdit default true;
    property Align default alClient;
    property Border: TBorderStyle read FBorder write SetBorder;
    property Color default clWhite;
    property Ctl3D;
    property Font;
    property TabOrder;
    property TabStop default true;
    property ShowAddress: Boolean read FShowAddress write SetShowAddress default True;
    property ShowCharacters: Boolean read FShowCharacters write SetShowCharacters default True;
    property AddressColor: TColor index 0 read GetFileColor write SetFileColor default clBlack;
    property HexDataColor: TColor index 1 read GetFileColor write SetFileColor default clBlack;
    property AnsiCharColor: TColor index 2 read GetFileColor write SetFileColor default clBlack;
    property SelectBrushColor: TColor index 3 read GetFileColor write SetFileColor default clBlue;
    property SelectFontColor: TColor index 4 read GetFileColor write SetFileColor default clYellow;
    property HighLightColor: TColor index 5 read GetFileColor write SetFileColor default clYellow;
    property AdjustWidth: byte read FAdjustWidth write FAdjustWidth;
    property AdjustHeight: byte read FAdjustHeight write FAdjustHeight;
    property ClipBoard:TClipB read FClipBoard write FClipBoard;
    property PopupMenu;
    property ParentFont;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnKeyPress;
    property OnChange:TNotifyEvent read FChange write FChange;
    property OnChangePosition:TPositionEvent read FChangePos write FChangePos;
    property OnStoreUndo:TStoreUndoEvent read FStoreUndo write FStoreUndo;
  end;

implementation

{Pomocn funkce}
function Max(Value1,Value2:integer):integer;
begin
  if Value1>Value2 then
    Result:=Value1
  else
    Result:=Value2;
end;

function Min(Value1,Value2:integer):integer;
begin
  if Value1<Value2 then
    Result:=Value1
  else
    Result:=Value2;
end;

{TClipB}

constructor TClipB.Create;
begin
	inherited Create;
  CF_MEMORY:=RegisterClipboardFormat('Memory block');
end;

function TClipB.GetSelected;
begin
	Result:=cbEnd>cbBegin;
end;

function TClipB.SetPosition;
var temp:integer;
begin
  if Select then
  	begin
		 	// dochz k oznaen
		  if cbBegin = -1 then
		  	cbBegin:=FPosition;
		  if (FPosition=cbEnd) or (cbEnd = -1) then
   			cbEnd:=Position
		  else
   			cbBegin:=Position;
		  if cbEnd<cbBegin then
   			begin
		     	temp:=cbEnd;
    		 	cbEnd:=cbBegin;
		      cbBegin:=temp;
    		end;
		 	Result:=FPosition<>Position;
	  end
  else
  	Result:=UnSelect;
  FPosition:=Position;
end;

function TClipB.UnSelect;
begin
  Result:=cbEnd<>-1;
 	cbEnd:=-1;
  cbBegin:=-1;
end;

procedure TClipB.CopyToClip;
var Buffer:pointer;
		Size:integer;
		Data:THandle;
    SrcPtr:PByteArray;
    DestPtr:PByteArray;
    i,j:integer;
begin
	if not Selected then exit;
	Buffer:=pointer(Integer(OffSet)+cbBegin);
  Size:=cbEnd-cbBegin;
	case FClipFormat of
  	cfText: begin
    				// odstrann znaku 00 a zkrcen na oznaenou dlku
    				Data:= GlobalAlloc(GMEM_MOVEABLE,Size+1);
	          SrcPtr:=Buffer;
            try
             	DestPtr:=GlobalLock(Data);
              try
                i:=0;
              	j:=0;
              	while i<Size do
	                begin
                  	if SrcPtr[i]<>0 then
                    	begin
			                	DestPtr[j]:=SrcPtr[i];
                        j:=j+1;
                      end;
	                  i:=i+1;
  	              end;
                Size:=j;
                DestPtr[Size]:=0;
								SetBuffer(CF_TEXT,DestPtr^,Size+1);
              finally
              	GlobalUnLock(Data);
              end;
            finally
            	GlobalFree(Data);
            end;
    			end;
    cfMemory:	begin
    					Data:=GlobalAlloc(GMEM_MOVEABLE, Size+SizeOf(Size));
              try
              	DestPtr:=GlobalLock(Data);
                try
									Buffer:=pointer(Integer(OffSet)+cbBegin);
                  Move(Size,DestPtr^,SizeOf(Size));	// zpis daje o velikosti
                  DestPtr:=pointer(integer(DestPtr)+SizeOf(Size));
                  Move(Buffer^,DestPtr^,Size);
                  SetAsHandle(CF_MEMORY,Data);
                finally
                	GlobalUnLock(Data);
                end;
              finally
              	GlobalFree(Data);
              end;
  					end;
  end;
end;

procedure TClipB.PasteFromClip;
var Data:THandle;
	  Src:PByteArray;
    Dest:PByteArray;
begin
	if Offset=nil then exit;
	Open;
  Dest:=pointer(integer(Offset)+FPosition);
	Data:=GetClipBoardData(CF_TEXT);
	if boolean(Data) then
	 	begin
			Src:=GlobalLock(Data);
      try
      	Move(Src^,Dest^,GetSizeOfData);
      finally
      	GlobalUnLock(data);
      end;
	  end;
  Data:=GetClipBoardData(CF_MEMORY);
	if boolean(Data) then
  	begin
    	Src:=GlobalLock(Data);
      try
  	    Src:=pointer(integer(Src)+Sizeof(SizeOfData));
    	  Move(Src^,Dest^,GetSizeOfData);
      finally
      	GlobalUnLock(Data);
      end;
    end;
  Close;
end;

function TClipB.GetSizeOfData;
var Ptr:PByteArray;
		Data:THandle;
begin
	Data:=GetAsHandle(CF_TEXT);    	
	if boolean(Data) then
  	begin
    	Ptr:=GlobalLock(Data);
      try
      	Result:=0;
        while Ptr^[Result]<>0 do
        	Result:=Result+1;
      finally
      	GlobalUnLock(Data);
      end;
    end;
	Data:=GetAsHandle(CF_MEMORY);
	if boolean(Data) then
  	begin
    	Ptr:=GlobalLock(Data);
      try
      	Move(Ptr^,Result,SizeOf(Result));
      finally
      	GlobalUnLock(Data);
      end;
    end;
end;

procedure TClipB.SetBuffer(Format: Word; var Buffer; Size: Integer);
var
  Data: THandle;
  DataPtr: Pointer;
begin
  try
    Data := GlobalAlloc(GMEM_MOVEABLE, Size);
    try
      DataPtr := GlobalLock(Data);
      try
        Move(Buffer, DataPtr^, Size);
        SetAsHandle(Format, Data);
      finally
        GlobalUnlock(Data);
      end;
    except
      GlobalFree(Data);
      raise;
    end;
  finally
  end;
end;

{TCur}

constructor TCur.Create;
begin
	inherited Create;
  FHandle:=Han;
end;

destructor TCur.Destroy;
begin
  DestroyCaret;
  inherited;
end;

procedure TCur.SetVisible;
begin
  FVisible:=Vis;
  Update;
end;

procedure TCur.SetPoint;
begin
  FPoint:=Pnt;
  Update;
end;

procedure TCur.SetHeight;
begin
  if FHeight = Height then exit;
  FHeight:=Height;
  Update;
end;

procedure TCur.Update;
begin
  DestroyCaret;
  CreateCaret(FHandle,0,1,FHeight);
  SetCaretPos(FPoint.X,Fpoint.Y);
  if FVisible then
    ShowCaret(FHandle);
end;

{ THexDump }

constructor THexDump.Create(AOwner: TComponent);
var i:integer;
begin
  inherited Create(AOwner);

  FClipBoard:=TClipB.Create;
  FClipBoard.cbBegin:=-1;
  FClipBoard.cbEnd:=-1;
  FClipBoard.ClipBoardFormat:=cfMemory;

//  FCursor:=TCur.Create(Handle);

  FMemory:=TMemoryStream.Create;

  ControlStyle:=[csFramed];
  FBorder:=bsSingle;
  Color:=clWhite;
  SelectBrushColor:=clHighlight;
  SelectFontColor:=clYellow;
  HighLightColor:=clYellow;
  FShowAddress := True;
  FShowCharacters := True;
  Width := 300;
  Height := 200;
  Cursor:=crIBeam;
	DragCursor:=crIBeam;
  FillChar(FHexData, SizeOf(FHexData), #9);
  FCurrentLine:=0;
  Self.DragMode:=dmManual;
  Align:=alClient;
  CanEdit:=true;
  TabStop:=true;
  FHexEdit:=true;
  // naplnn pevodn tabulky (tj. A se zobrazi jako A)
  for i:=0 to 255 do
    Translate[i]:=Char(i);

end;

destructor THexDump.Destroy;
begin
	FMemory.Free;
	FCursor.Free;
  FClipBoard.Free;
  inherited Destroy;
end;

procedure THexDump.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    if FBorder = bsSingle then
      Style := Style or WS_BORDER;
    Style := Style or WS_VSCROLL;
  end;
end;

procedure THexDump.CreateWindowHandle;
begin
  inherited ;
  // nsledujc dky mus bt zde, nebo vyaduj Handle
  FCursor:=TCur.Create(Handle);
  // nsl. dky zaru stejnou ku znak pro nkter fonty
  Font.Name:='System';
  Font.Charset:=DEFAULT_CHARSET;
  Font.Pitch:=fpFixed;
end;


{ VCL Command Messages }

procedure THexDump.CMFontChanged(var Message: TMessage);
begin
  inherited;
  Canvas.Font := Self.Font;
  FItemHeight := Canvas.TextHeight('A') + AdjustHeight;
  FItemWidth := Canvas.TextWidth('D') + AdjustWidth;
  CalcPaintParams;
  AdjustScrollBars;
end;

procedure THexDump.CMEnter;
begin
  inherited;
{  InvalidateLineMarker; }
end;

procedure THexDump.CMExit;
begin
  inherited;
{  InvalidateLineMarker; }
end;

{ Windows Messages }

procedure THexDump.WMSize(var Message: TWMSize);
begin
  inherited;
  if FCursor = nil then exit;
  CalcPaintParams;
  SetSelectPosition(Position,true);
  AdjustScrollBars;
end;

procedure THexDump.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTARROWS;
end;

procedure THexDump.WMSetFocus;
begin
	inherited;
	FCursor.Visible:=true;
end;

procedure THexDump.WMKillFocus;
begin
	inherited;
	FCursor.Visible:=false;
end;

procedure THexDump.WMVScroll(var Message: TWMVScroll);
var
  ScrollInfo:TScrollInfo;
  NewTopLine: Integer;
begin
  inherited;
  NewTopLine := FTopLine;
  case Message.ScrollCode of
    SB_LINEDOWN: Inc(NewTopLine);
    SB_LINEUP: Dec(NewTopLine);
    SB_PAGEDOWN: Inc(NewTopLine, FVisibleLines - 1);
    SB_PAGEUP: Dec(NewTopLine, FVisibleLines - 1);
    SB_THUMBPOSITION, SB_THUMBTRACK:
      with ScrollInfo do
        begin
          cbSize:=SizeOf(ScrollInfo);
          fMask:=SIF_TRACKPOS;
          GetScrollInfo(Handle,SB_VERT,ScrollInfo);
          NewTopLine := nTrackPos;
        end;
  end;

  if NewTopLine < 0 then NewTopLine := 0;
  if NewTopLine >= FLineCount-1 then
    NewTopLine := FLineCount - 1;

  FCursor.Visible:=false;
  SetTopLine(NewTopLine);
  CalcCurParams;
  FCursor.Visible:=Focused;
end;

{ Painting Related }

procedure THexDump.CalcPaintParams;
const
  Divisor: array[boolean] of Integer = (3,4);
var
  CharsPerLine: Integer;
  OldBytesPerLine: Integer;
begin
  if FItemHeight < 1 then
    Perform(CM_FONTCHANGED,0,0);
  if FItemHeight <1 then
    exit;
  FVisibleLines := ClientHeight div FItemHeight;
  CharsPerLine := ClientWidth div FItemWidth;
  if FShowAddress then Dec(CharsPerLine, 10);
  if FShowCharacters then Dec(CharsPerLine, 1);
  OldBytesPerLine:=FBytesPerLine;
  FBytesPerLine := CharsPerLine div Divisor[FShowCharacters];
  if FBytesPerLine < 1 then
    FBytesPerLine := 1
  else if FBytesPerLine > MAXDIGITS then
    FBytesPerLine := MAXDIGITS;
  FLineCount := (DataSize div FBytesPerLine) + integer((DataSize mod FBytesPerLine) =0);
  if Boolean(DataSize mod FBytesPerLine) then Inc(FLineCount);
  if FBytesperLine <> OldBytesPerLine then
    SetTopLine(FTopLine * OldBytesPerLine div FBytesPerLine);
  CalcCurParams;
end;

procedure THexDump.CalcCurParams;
var x,y:integer;
begin
	try
		x:=FPosition mod FBytesPerLine;
  	y:=FCurrentLine - FTopLine;
	  if FHexEdit then
			x:=(x*3+10*Integer(FShowAddress)+Integer(FHalf))*FItemWidth
	  else
  		x:=(x+10*Integer(FShowAddress)+FBytesPerLine*3+AdjustWidth+1)*(FItemWidth-AdjustWidth);
	  y:=y*FItemHeight;
  	FCursor.Point:=Point(x,y);
	  FCursor.Height:=FItemHeight-AdjustHeight;
  except
  	FCursor.Visible:=false;
  end;
end;

procedure THexDump.AdjustScrollBars;
var ScrollInfo:TScrollInfo;
begin
  if (FLineCount<=FVisibleLines) or (FLineCount = 0) then
    	ShowScrollBar(Handle,SB_VERT,false)
  else
    with ScrollInfo do
    	begin
        cbSize:=SizeOf(ScrollInfo);
        nMin:=0;
        nMax:=FLineCount;
        nPage:=FVisibleLines;
        nPos:=FTopLine;
        fMask:=SIF_PAGE or SIF_RANGE or SIF_POS;
        SetScrollInfo(Handle,SB_VERT,ScrollInfo,true);
   	  	ShowScrollBar(Handle,SB_VERT,true);
      end;
end;

// zobraz jeden dek s respektovnm oznaenho bloku
procedure THexDump.PaintLine;
var AddressWidth:integer;
    BorderColor:TColor;
    R:TRect;
begin
  // to co nen vidt nen teba vykreslovat
  if (Line < FTopLine) or (Line >= FTopLine + FVisibleLines) then
    exit;

  if FShowAddress then
    AddressWidth := FItemWidth*10
  else
    AddressWidth := 0;

  R := Bounds(0, 0, AddressWidth, FItemHeight);
  OffSetRect(R , 0 , (Line - FTopLine) * FItemHeight);

  if CanHigh then
    BorderColor := HighLightColor
  else
    BorderColor := Color;
  Canvas.Brush.Color:=BorderColor;

  if FShowAddress then
    begin
      Canvas.Font.Color := FFileColors[0];
      ExtTextOut(Canvas.Handle, R.Left, R.Top, ETO_OPAQUE or ETO_CLIPPED, @R, LineAddr(Line), 9, nil);
    end;

  R.Left := R.Right;
  R.Right := R.Left + FItemWidth*(FBytesPerLine*3+1);

  Canvas.Font.Color := FFileColors[1];
  SelectedTextOut(Line,R,true,BorderColor);

  R.Left := R.Right;
  R.Right := R.Left + FItemWidth * FBytesPerLine;

  if FShowCharacters then
    begin
      Canvas.Font.Color := FFileColors[2];
      SelectedTextOut(Line,R,false,BorderColor);
    end;
end;

procedure THexDump.SelectedTextOut;
// vstup hexa dat s oetenm zabarven oznaenho msta
var  TabStop: Integer;
		 off:integer;
     bytecount:integer;
     Interval:integer;
begin
  if writehex then
    SetLineData(Line)
  else
    SetChars(Line);
  Canvas.Brush.Color:=BorderColor;
  TabStop := FItemWidth*3;
  Interval:=Line*FBytesPerLine;
  off:=0;
  if (FClipBoard.cbBegin > Interval) and
     (FClipBoard.cbBegin <Interval+FBytesPerLine) then
     // zatek bloku
  	begin
    	bytecount:=FClipBoard.cbBegin-Interval;
      if bytecount <= 0 then
      	raise Exception.Create(Format('bytecount je na hovno:'#13'bytecount = %d'#13'cbBegin =  %d'#13'Interval = %d',[bytecount,FClipboard.cbBegin,Interval]));
      if Writehex then
        begin
          // vpis hexa dat
    		  TabbedTextOut(Canvas.Handle, R.Left, R.Top,FHexData[0],
        		3*bytecount, 1, TabStop, R.Left);
          R.Left:=R.Left+3*FItemWidth*bytecount;
        end
      else
        // vpis znak
        begin
          ExtTextOut(Canvas.Handle, R.Left, R.Top,
            ETO_OPAQUE or ETO_CLIPPED, @R, @FCharData, bytecount, nil);
          R.Left:=R.Left+FItemWidth*bytecount;
        end;
      off:=bytecount;
    end;
  if (FClipBoard.cbEnd >Interval+off) and
  	 (FClipBoard.cbBegin<Interval+FBytesPerLine) then
     // konec bloku
  	begin
      Canvas.Brush.Color:=SelectBrushColor;
      Canvas.Font.Color:=SelectFontColor;
    	bytecount:=FClipBoard.cbEnd-Interval;
      if bytecount>FBytesPerLine then
      	bytecount:=FBytesPerLine-off
      else
      	bytecount:=bytecount-off;
      if Writehex then
        begin
    		  TabbedTextOut(Canvas.Handle, R.Left, R.Top,FHexData[off],
        		3*bytecount - integer(off + bytecount >=FBytesPerLine), 1, TabStop, R.Left);
          R.Left:=R.Left+3*FItemWidth*bytecount;
        end
      else
        begin
          ExtTextOut(Canvas.Handle, R.Left, R.Top,
            ETO_OPAQUE or ETO_CLIPPED, @R, @FCharData[off], bytecount, nil);
          R.Left:=R.Left+FItemWidth*bytecount;
        end;
      off:=off+bytecount;
    end;
  // za blokem
  if Writehex then
    Canvas.Font.Color:=HexDataColor
  else
    Canvas.Font.Color:=AnsiCharColor;
  Canvas.Brush.Color:=BorderColor;
 	bytecount:=FBytesPerLine-off;
  if Writehex then
    begin
      TabbedTextOut(Canvas.Handle, R.Left, R.Top,FHexData[off],
        3*bytecount-1, 1, TabStop, R.Left);
    end
  else
    begin
      ExtTextOut(Canvas.Handle, R.Left, R.Top,
        ETO_OPAQUE or ETO_CLIPPED, @R, @FCharData[off], bytecount, nil);
      R.Left:=R.Left+FItemWidth*bytecount;
    end;
end;

procedure THexDump.AssignStream;
begin
	FMemory.LoadFromStream(Stream);
//	SetActive(FMemory.Size<>0);
  CalcPaintParams;
  AdjustScrollBars;
  Invalidate;
end;

procedure THexDump.AssignToStream;
begin
	Stream.WriteBuffer(FMemory.Memory^,FMemory.Size);
end;

procedure THexDump.SetCurrentLine(Value: Integer);
var OldCurrentLine:integer;
begin
  if Value <> FCurrentLine then
  begin
    if Value < 0 then Value := 0;
    if Value >= FLineCount then Value := FLineCount - 1;

    // aktualizace souasnho dku
    PaintLine(FCurrentLine,false);

    OldCurrentLine:=FCurrentLine;
    FCurrentLine:=Value;

    if (Value < FTopLine) or (Value >= (FTopLine + FVisibleLines)) then
      SetTopLine(Value - (OldCurrentLine - FTopLine));


    if (FCurrentLine<FTopLine) or (FCurrentLine>FTopLine + FVisibleLines) then
      SetTopLine(FCurrentLine);
  end;
  // vykreslen aktulnho dku
  PaintLine(FCurrentLine,true);
end;

procedure THexDump.Paint;
var
  I: Integer;
begin
//  inherited Paint;
  if csDesigning	in Self.ComponentState then
    begin
    	Canvas.Brush.Color := clInactiveBorder;
      Canvas.FillRect(ClientRect);
      exit;
    end;
  Canvas.Brush.Color := Self.Color;
  for I := 0 to FVisibleLines - 1 do
  begin
    PaintLine(FTopLine + I,FTopLine+I = FCurrentLine);
  end;
end;

procedure THexDump.WriteByte;
var Mem:PByte;
		HexDigit: byte;
begin
	if not FCanEdit then exit;
  if Assigned(OnStoreUndo) then
    OnStoreUndo(Self,otWrite,Position,B);
  if FHexEdit then
  	begin
    	B:=Ord(UpCase(Char(B)));
    	HexDigit := B - 48 -Integer(B>64)*(65-58);
      if not (HexDigit in [0..15]) then exit;
			if Position=DataSize then
  			Insert(DataSize,1);
    	Mem:=Ptr(Position+Integer(Address));
		  if FHalf then
		  	begin
        	Mem^:=(Mem^ and $F0) or HexDigit;
	  		  SetSelectPosition(Position+1,false);
		    end
		  else
      	begin
      		Mem^:=(Mem^ and $F) or (HexDigit*16);
         	FHalf:=true;
          CalcCurParams;
				end;
    end
  else
    	begin
	  		if Position=DataSize then
  	  		Insert(DataSize,1);
      	Mem:=Ptr(Position+Integer(Address));
	    	Mem^:=B and 255;
        SetSelectPosition(Position+1,false);
      end;
  PaintLine(CurrentLine,true);
  if Assigned(OnChange) then OnChange(Self);
end;

procedure THexDump.Delete;
var Dest,Src:pointer;
begin
	if not FCanEdit then exit;
	if Pos+Size>=Self.DataSize then
  	Size:=DataSize-Pos;
  if Assigned(OnStoreUndo) then
    OnStoreUndo(Self,otDelete,pos,Size);
	Dest:=pointer(integer(Address)+Pos);
	Src:=pointer(integer(Dest)+Size);
  FMemory.Position:=Pos;
	Move(Src^,Dest^,DataSize-Size-Pos);
  DataSize:=DataSize-Size;
//  SetActive(DataSize<>0);
  if Assigned(OnChange) then OnChange(Self);
end;

procedure THexDump.Insert;
var Dest,Src:pointer;
begin
	if not FCanEdit then exit;
  if Assigned(OnStoreUndo) then
    OnStoreUndo(Self,otInsert,pos,Size);
	DataSize:=DataSize+Size;
	Src:=pointer(integer(Address)+Pos);
	Dest:=pointer(integer(Src)+Size);
	Move(Src^,Dest^,DataSize-Size-Pos);
  FillChar(Src^,Size,0);
//  SetActive(DataSize<>0);
  if Assigned(OnChange) then OnChange(Self);
end;

{ Event Overrides }

procedure THexDump.KeyDown(var Key: Word; Shift: TShiftState);
var NewPos:integer;
begin
  inherited KeyDown(Key, Shift);
  // klvesy, jen mohou aktivovat HexDump vloenm znak (CTRL+V a INSERT)
  if (ssCtrl in Shift) and (Key=Ord('V')) and FCanEdit then
		begin
      with FClipBoard do
      	begin
					Insert(Position,GetSizeOfData);
         	PasteFromClip(Address);
		      SetSelectposition(Position,false);
		      cbBegin:=Position;
		      SetSelectposition(Position+GetSizeOfData,true);
        end;
      CalcPaintParams;
      Key:=0;
		end;
	if Key= VK_INSERT then
  	begin
  		Insert(Position,1);
      CalcPaintParams;
      Paint;
		end;


  NewPos:=Position;

  if ssCtrl in Shift then
	  case Key of
	    VK_DOWN,VK_UP:
               	begin
                  FCursor.Visible:=false;
                  SetTopLine(FTopLine+1-2*Integer(Key=VK_DOWN));
                  FCursor.Visible:=Focused;
                end;
	    VK_HOME:  NewPos:=0;
  	  VK_END: 	NewPos:=DataSize;
      ord('C'): begin
      						FClipBoard.CopyToClip(Address);
                  Key:=0;	// po stlaen CTRL+C se nezru vbr
      					end;
      ord('X'): begin
                  with FClipBoard do
                    begin
        						  CopyToClip(Address);
      								Delete(cbBegin,cbEnd-cbBegin);
                   		SetSelectPosition(cbBegin,false);
                    end;
                  CalcPaintParams;
                  Key:=0;
                  FClipBoard.UnSelect;
                  Paint;
      					end;
    else
    	Key:=0
    end
  else
	  case Key of
  		VK_RIGHT: Inc(NewPos,1);
  		VK_LEFT:  Inc(NewPos,-1);
	    VK_DOWN:  Inc(NewPos,FBytesPerLine);
  	  VK_UP: 	  Inc(NewPos,-FBytesPerLine);
    	VK_NEXT:  Inc(NewPos,FBytesPerLine*FVisibleLines);
	    VK_PRIOR: Inc(NewPos,-FBytesPerLine*FVisibleLines);

	    VK_HOME:  NewPos:=FBytesPerLine*FTopLine;
  	  VK_END:   NewPos:=FBytesPerLine*(FTopLine+FVisibleLines)-1;
    	VK_F6: HexEdit:=not HexEdit;
      VK_DELETE:	begin
      							with FClipBoard do
                    	if Selected then
                      	begin
			      							Delete(cbBegin,cbEnd-cbBegin);
                          SetSelectPosition(FClipBoard.cbBegin,false);
                        end
                      else
		      							Delete(Position,1);
                    FCursor.Visible:=Focused;
                    FClipBoard.UnSelect;
                    CalcPaintParams;
                    Paint;
      						end;
	  else
  		begin
       	if Key in [VK_NUMPAD0..VK_NUMPAD9] then
         	Key:=Key-VK_NUMPAD0+ord('0');
 		  	if FHexEdit and not FClipBoard.Selected then
          begin
            FCursor.Visible:=false;
  				 	WriteByte(Key);
            FCursor.Visible:=Focused;
          end;
    	end;
	  end;
  if Key in [VK_LEFT,VK_DOWN,VK_UP,VK_RIGHT,VK_NEXT,VK_END,VK_HOME,VK_PRIOR] then
    SetSelectposition(NewPos,ssShift in Shift);
end;

procedure THexDump.KeyPress;
begin
	inherited;
 	if not FHexEdit and not FClipBoard.Selected then
	 	WriteByte(Ord(Key));
end;

procedure THexDump.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  if ssRight in Shift then exit;	// pro ppad zaven PopupMenu
  if not Focused then SetFocus;
  if not (ssShift in Shift) and FClipBoard.Unselect then
  	Paint;
  if (Button = mbLeft) then
  	SetSelectPosition(GetPositionAt(X,Y),ssShift in Shift);
end;

procedure THexDump.MouseUp;
begin
  inherited;
  ReleaseCapture;
end;

procedure THexDump.MouseMove;
begin
	inherited;
	if Shift = [ssLeft] then
  begin
    SetCapture(Handle);
  	Self.BeginDrag(false);
  end;
end;

procedure THexDump.DragOver;
begin
	inherited;
  FCursor.Visible:=false;
  if Y>=FItemHeight*FVisibleLines then
    Y:=FItemHeight*FVisibleLines-1;
  SetSelectPosition(GetPositionAt(X,Y),true);
  Accept:=true;
  FCursor.Visible:=Focused;
end;

{ Property Set/Get Routines }

procedure THexDump.SetSelectPosition;
var i:integer;
    firstline:integer;
    countline:integer;
    accept:boolean;
begin
	Pos:=Min(Pos,DataSize);
  Pos:=Max(0,Pos);
  accept:=true;
  if Assigned(OnChangePosition) then
    OnChangePosition(Self,Pos,accept);
  if not accept then exit;

  FCursor.Visible:=false;
	FPosition:=Pos;

  if FClipboard.SetPosition(Pos,CanSelect) then
    begin
      firstline:=Min(FCurrentLine,FPosition div FBytesPerLine);
      countline:=Abs(FCurrentLine-FPosition div FBytesPerLine)+firstline;
      SetCurrentLine(FPosition div FBytesPerLine);
      if FClipBoard.Selected then
          for i:=FirstLine to countline do
            PaintLine(i,i = FCurrentLine)
      else
        Paint;
    end
  else
    SetCurrentLine(FPosition div FBytesPerLine);

  FHalf:=false;
  CalcCurParams;
  FCursor.Visible:=Focused;
end;

procedure THexDump.SetBorder(Value: TBorderStyle);
begin
  if Value <> FBorder then
  begin
    FBorder := Value;
    RecreateWnd;
  end;
end;

procedure THexDump.SetShowAddress(Value: Boolean);
begin
  if FShowAddress <> Value then
  begin
    FShowAddress := Value;
    Invalidate;
  end;
end;

procedure THexDump.SetShowCharacters(Value: Boolean);
begin
  if Value <> FShowCharacters then
  begin
    FShowCharacters := Value;
    Invalidate;
  end;
end;

procedure THexDump.SetFileColor(Index: Integer; Value: TColor);
begin
  if FFileColors[Index] <> Value then
  begin
    FFileColors[Index] := Value;
    Invalidate;
  end;
end;

function THexDump.GetFileColor(Index: Integer): TColor;
begin
  Result := FFileColors[Index];
end;

function THexDump.GetAddress;
begin
	Result:=FMemory.Memory;
end;

procedure THexDump.SetHexEdit;
begin
	FHexEdit:=Hex or not FShowCharacters;
  CalcCurParams;
end;

function THexDump.GetDataSize;
begin
  if FMemory = nil then
    Result:=0
  else
  	Result:=FMemory.Size;
end;

procedure THexDump.SetDataSize;
begin
	FMemory.Size:=Value;
  CalcPaintParams;
  Paint;
  AdjustScrollBars;
end;

procedure THexDump.SetTopLine(Value: Integer);
var
  ScrollInfo:TScrollInfo;
  LinesMoved: Integer;
  R: TRect;
begin
  if Value <> FTopLine then
  begin
    if Value < 0 then Value := 0;
    if Value >= FLineCount then Value := FLineCount - 1;

    LinesMoved := FTopLine - Value;  // kladny .. posun dolu
    FTopLine := Value;
    with ScrollInfo do
      begin
        cbSize:=SizeOf(ScrollInfo);
        fMask:=SIF_POS;
        nPos:=FTopLine;
      end;
    SetScrollInfo(Handle, SB_VERT, ScrollInfo,true);

    if Abs(LinesMoved) = 1 then
    begin
      R := Bounds(1, 0, ClientWidth, FItemHeight*(FVisibleLines-1));
      Case LinesMoved of
        1:begin
            with Canvas do
              BitBlt(handle,1,R.Top+FItemHeight,ClientWidth,R.Bottom,
                handle,1,R.Top,Windows.SRCCOPY);
            PaintLine(FTopLine,FTopLine = FCurrentLine);
          end;
       -1:begin
            with Canvas do
              BitBlt(handle,1,R.Top,ClientWidth,R.Bottom,
                handle,1,R.Top+FItemHeight,Windows.SRCCOPY);
            PaintLine(FTopLine+FVisibleLines-1,FTopLine+FVisibleLines-1 = FCurrentLine);
          end;
      end;
    end
    else
      Paint;
  end;
end;

function THexDump.GetPositionAt;
var HexWidth:integer;
begin
	Result:=Position;
  if FShowAddress then X:=X-10*FItemWidth;
  HexWidth:=3*FBytesPerLine*FItemWidth;
  if X<-1 then X:=0;
  if X>=HexWidth+(FBytesPerLine+1)*(FItemWidth-AdjustWidth)+1 then
  	X:=HexWidth-1;
  if ((X>HexWidth) and (X<HexWidth+FItemWidth)) then exit;
  HexEdit:=(X<HexWidth);
  Result := (FTopLine + (Y div FItemHeight))*FBytesPerLine;
  if FHexEdit then
    Result := Result + (X+FItemWidth) div (3*FItemWidth)
  else
   	Result := Result + (X -HexWidth) div (FItemWidth-AdjustWidth)-1;
end;

function THexDump.LineAddr(Index: Integer): PChar;
begin
  if Index < FLineCount then
    Result := StrFmt(FLineAddr, '%p:',
  	   [Pointer(Cardinal(Index*FBytesPerLine)+FAddressOffset)])
  else
    Result := '          ';
end;

procedure THexDump.SetLineData(Index: Integer);

  procedure SetData(P: PChar);
  const
    HexDigits : array[0..15] of Char = '0123456789ABCDEF';
  var
    I: Integer;
    B: Byte;
  begin
    fillchar(FHexData,MAXDIGITS*3,ord(' '));
    for I := 0 to FBytesPerLine-1 do
    begin
      try
        if not (integer(P-Address+I) >= DataSize) then
        	begin
		        B := Byte(P[I]);
    		    FHexData[I][0] := HexDigits[B SHR $04];
		        FHexData[I][1] := HexDigits[B AND $0F];
          end;
      except
        FHexData[I][0] := '?';
        FHexData[I][1] := '?';
      end;
    end;
  end;

begin
  SetData(PChar(Address) + Index*FBytesPerLine);
end;

procedure THexDump.SetChars(Index: Integer);
type TCharArray = array [0..MAXDIGITS] of char;
var i:integer;
    pos:integer;
    ch:^TByteArray;
begin
  pos:=Index*FBytesPerLine;
  ch:=Address;
  for i:=0 to MAXDIGITS-1 do
    begin
      if pos + i < DataSize then
        FCharData[i]:=Translate[ch[pos+i]]
      else
        FCharData[i]:=' ';
    end;
  FCharData[MAXDIGITS]:=#0;
end;

procedure THexDump.SetAddressOffSet;
begin
  if FAddressOffset = Offset then exit;
  FAddressOffset:=Offset;
  Invalidate;
end;

end.
