{*******************************************************}
{                                                       }
{       SelectZIP:Vbr zip souboru                     }
{                                                       }
{       Vyrobeno  (c) 2003, Z6 (zdeno6@seznam.cz)       }
{                                                       }
{*******************************************************}
unit SelectZIP;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,MediaSource,ZIpEditForm,ZIPStream, ExtCtrls;

type
  TSelZIP = class(TForm)
    ListBox: TListBox;
    Button1: TButton;
    Button3: TButton;
    OpenDialog: TOpenDialog;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ListBoxDblClick(Sender: TObject);
  private
    { Private declarations }
    FPath:string;
    procedure SetPath(const Value:string);
    procedure UpdateListFile;
  public
    { Public declarations }
    property PathName:string read FPath write SetPath;
  end;

var
  SelZIP: TSelZIP;

implementation

{$R *.dfm}

{ TSelZIP }

procedure TSelZIP.Button1Click(Sender: TObject);
begin
  if OpenDialog.Execute then
    PathName:=OpenDialog.FileName;
end;

procedure TSelZIP.Button3Click(Sender: TObject);
var form:TmainForm;
    src,dest:TFileStream;
    nm:string;
    ok:Boolean;
begin
  if (ListBox.Count = 0) or (ListBox.ItemIndex<0) then exit;
  ok:=false;
  form:=TMainForm.Create(nil);
  src:=nil;
    try
      with ListBox do
        nm:=Items[ItemIndex];
      form.SourceName:=nm;
      nm:=OpenDialog.InitialDir+'\'+nm;
      src:=TFileStream.Create(nm,fmOpenRead);
      form.Source:=src;
      form.ShowModal;
      if form.ModalResult = IDYES then begin
        dest:=TFileStream.Create(nm+'$',fmCreate);
        try
          form.Z.SaveZIPToStream(dest);
          ok:=true;
        finally
          dest.Free;
        end;
      end;
    finally
      form.Free;
      src.Free;
    end;
    If not ok then exit;
    DeleteFile(nm);
    RenameFile(nm+'$',nm);
end;

procedure TSelZIP.SetPath(const Value: string);
begin
  FPath:=Value;
  OpenDialog.InitialDir:=ExtractFilePath(Value);
  OpenDialog.FileName:=ExtractFileName(Value);
  UpdateListFile;
end;

procedure TSelZIP.UpdateListFile;
var sr:TSearchRec;
    l:Cardinal;
    strm:TStream;
begin
  ListBox.Clear;
  if FindFirst(FPath, 0, sr) = 0 then begin
    repeat;
      // vyazen soubor bez ZIP signatury
      SetCurrentDir(OpenDialog.InitialDir);
      strm:=TStream(TFileStream.Create(sr.Name,fmOpenRead));
      try
        if (strm.Size>0) then begin
          if (strm.Size<98) then Continue
          else begin
            strm.Read(l,4);
            if l<>LOCHEADER_SIG then Continue;
          end;
        end;
      finally
        strm.Free;
      end;
      ListBox.Items.Add(ExtractFileName(sr.Name));
    until FindNext(sr) <> 0;
    FindClose(sr);
  end;
end;

procedure TSelZIP.ListBoxDblClick(Sender: TObject);
begin
  Button3Click(Self);
end;

end.
