{*******************************************************}
{                                                       }
{       ZIPEditForm:Editor zip soubor                  }
{                                                       }
{       Vyrobeno  (c) 2003, Z6 (zdeno6@seznam.cz)       }
{                                                       }
{*******************************************************}
unit ZIPEditForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Dialogs, ComCtrls, ExtCtrls,StrUtils, Controls, Forms,
  ShellApi,CommCtrl, ImgList, JPEG,TGA, StdCtrls,
  SelectForm,ZIPStream, ToolWin,HexDump;

// koncovky editovatelnch soubor
const imageext:array [0..2] of string =('.bmp','.jpg','.tga');
      WARNFILEEXISTS = 'Nelze pejmenovat, soubor ji existuje!';
type
  TItem = record
    IsFolder:Boolean;
    Caption:string;
    FileHeader:PFileHeader;
    SmallImageIndex:Integer;
    LargeImageIndex:Integer;
  end;

  TData = array of TItem;
  PData = ^TData;

  TStoreInfo = record
    Stored:Boolean;
    SWidth,SHeight,STop,SLeft:Integer;
  end;

  TMainForm = class(TForm)
    OpenDialog1: TOpenDialog;
    ToolbarImages: TImageList;
    Notebook: TNotebook;
    TreeView: TTreeView;
    ListView: TListView;
    Splitter1: TSplitter;
    CoolBar1: TCoolBar;
    ToolBar2: TToolBar;
    btnBack: TToolButton;
    ToolButton3: TToolButton;
    btnLargeIcons: TToolButton;
    btnSmallIcons: TToolButton;
    btnList: TToolButton;
    btnReport: TToolButton;
    CoolBar2: TCoolBar;
    ToolBar1: TToolBar;
    btnPrevImage: TToolButton;
    btnNextImage: TToolButton;
    ImageInfo: TStatusBar;
    ToolButton1: TToolButton;
    btnImageFit: TToolButton;
    Shape1: TShape;
    Image: TImage;
    btnClose: TToolButton;
    ToolButton4: TToolButton;
    btnViewOpacity: TToolButton;
    TextEditor: TMemo;
    btnNewFolder: TToolButton;
    btnDelete: TToolButton;
    CoolBar3: TCoolBar;
    ToolBar3: TToolBar;
    ToolButton2: TToolButton;
    Panel1: TPanel;
    CoolBar4: TCoolBar;
    ToolBar4: TToolBar;
    ToolButton5: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TreeViewChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure TreeViewDeletion(Sender: TObject; Node: TTreeNode);
    procedure TreeViewGetImageIndex(Sender: TObject; Node: TTreeNode);
    procedure ListViewDblClick(Sender: TObject);
    procedure ListViewData(Sender: TObject; Item: TListItem);
    procedure btnIconsClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnNextImageClick(Sender: TObject);
    procedure btnPrevImageClick(Sender: TObject);
    procedure btnImageFitClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure NotebookPageChanged(Sender: TObject);
    procedure btnViewOpacityClick(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure btnNewFolderClick(Sender: TObject);
    procedure TreeViewEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure ListViewEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure TextEditorChange(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    FHexDump:THexDump;
    FName:string;
    FileStream:TFileStream;
    FFileChanged:Boolean;  // soubor byl editovn
    FZIPChanged:Boolean;    // ZIP byl zmnn
    EditedItem:TItem;
    FSource:TStream;
    ZIP:TZIP;
    iFolderSmall,iFolderLarge,iFolderOpen:Integer;
    PosInfo:TStoreInfo;   // schova aktulnch rozmr a pozice formule
    function NewDir(const Name:string;Parent:TTreeNode):TTreeNode;
    procedure SetSource(Value:TStream);
    procedure DirUpdate;
    procedure GetIcon(var Item:TItem);
    procedure BuildNodeList(Node:TTreeNode);
    procedure EditFile(const Item:TItem);
    function InitImageBrowser(const Item:TItem):Boolean;
    function InitTextEditor(const Item:TItem):Boolean;
    function InitHexEditor(const Item:TItem):Boolean;
    procedure AcceptDropFiles(var Message:TMessage);message WM_DROPFILES;
    procedure DeleteFolder(const Name:string);
    procedure OnHexChanged(Sender:TObject);
  public
    { Public declarations }
    property SourceName:string read FName write Fname;
    property Source:TStream read FSource write SetSource;
    property Z:TZIP read ZIP;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}
function Max(A,B:Integer):Integer;
begin
  if A>B then
    Result:=A
  else
    Result:=B;
end;

function Min(A,B:Integer):Integer;
begin
  if A>B then
    Result:=B
  else
    Result:=A;
end;

procedure ClearNodeList(Node:TTreeNode);
begin
  if (Node=nil) or (Node.Data=nil) then exit;
  PData(Node.Data)^:=nil;
  Node.Data:=nil;
end;

function GetPathFromNode(Node:TTreeNode):string;
begin
  if (Node = nil) or (Node.Text='*') then
    Result:=''
  else
    Result:=GetPathFromNode(Node.Parent)+Node.Text+'\';
end;

//////////////////////////////////////////////////////////
// zskn indexu ikony na zklad Item.Caption a Item.IsFolder
procedure TMainForm.GetIcon(var Item: TItem);
const Flags = SHGFI_USEFILEATTRIBUTES or SHGFI_SYSICONINDEX;
var FileInfo:TSHFileInfo;
begin
  if Item.IsFolder then begin
    Item.SmallImageIndex:=iFolderSmall;
    Item.LargeImageIndex:=iFolderLarge;
  end else begin
    SHGetFileInfo(PChar(Item.Caption),0,FileInfo,SizeOf(FileInfo),Flags or SHGFI_LARGEICON);
    Item.LargeImageIndex:=FileInfo.iIcon;
    SHGetFileInfo(PChar(Item.Caption),0,FileInfo,SizeOf(FileInfo),Flags or SHGFI_SMALLICON);
    Item.SmallImageIndex:=FileInfo.iIcon;
  end;
end;

/////////////////////////////////////////////////////////
// zhotoven seznamu poloek a jeho piazen k pslunmu
// Node
procedure TMainForm.BuildNodeList(Node: TTreeNode);
var nl:PData;
    i,l:Integer;
    p,e:String;
    fh:PFileHeader;
    n:TtreeNode;
begin
  // pokud nen zhotoven seznam soubor, zhotovme ho
  New(nl);
  Node.Data:=nl;
  if ZIP.Headers.Count=0 then exit;
  // nejprve vlome seznam podadres
  n:=Node.getFirstChild;
  while n<>nil do begin
    l:=Length(nl^);
    SetLength(nl^,l+1);
    with nl^[l] do begin
      Caption:=n.Text;
      IsFolder:=true;
      FileHeader:=nil;
    end;
    GetIcon(nl^[l]);
    n:=n.getNextSibling;
  end;
  // te projdeme vechny zznamy v ZIP.Headers
  p:=GetPathFromNode(Node);
  if p = '' then
    i:=0
  else
    i:=ZIP.FindHeader(p);
  if i>-1 then repeat
    fh:=PFileHeader(ZIP.Headers[i]);
    Inc(i);
    e:=ExtractFilePath(fh.FileName);
    if p = '' then begin
      if e<>'' then Continue;
    end else begin
      if e='' then Break;
      if (AnsiStrLIComp(PChar(p),PChar(e),Length(e))<>0) then break;
    end;
    if fh^.IsDirectory then Continue;
    l:=Length(nl^);
    SetLength(nl^,l+1);
    with nl^[l] do begin
      FileHeader:=fh;
      Caption:=ExtractFileName(fh^.FileName);
      IsFolder:=false;
    end;
    GetIcon(nl^[l]);
  until i>=ZIP.Headers.Count;
end;

/////////////////////////////////////////////////////////
// Sestaven adresov struktury
procedure TMainForm.DirUpdate;
  procedure AddDir(const Name:string;Parent:TTreeNode);
  var c1,c2:string;
      temp:TTreeNode;
  begin
    if (Name = '') then exit;
    if Parent  = nil then
      Parent:=TreeView.Items.GetFirstNode;
    temp:=Parent.getFirstChild;
    c1:=Copy(Name,0,Pos(PathDelim,Name)-1);
    c2:=RightStr(Name,Length(Name)-Length(c1)-1);
    while temp<>nil do begin
      if AnsiStrComp(PChar(temp.Text),PChar(c1)) = 0 then begin
        // nalezena sloka se jmnem
        AddDir(c2,temp);
        exit;
      end;
      temp:=temp.GetNext;
    end;
    // sloka neexistuje - vytvome
    temp:=TreeView.Items.AddChild(Parent,c1);
    AddDir(c2,temp);
  end;
var i:Integer;
    nowp,path:string;  // nynj a pedchoz cesta
    iscorrect:Boolean;
begin
  iscorrect:=false;
  TreeView.Items.BeginUpdate;
  path:='';
  try
    TreeView.Items.Clear;
    TreeView.Items.AddChildFirst(nil,'*');
    for i:=0 to ZIP.Headers.Count-1 do
      with PFileHeader(ZIP.Headers[i])^ do begin
        nowp:=ExtractFilePath(FileName);
        if IsDirectory then begin
          AddDir(FileName,nil);
          iscorrect:=true;
        end else if not iscorrect and not SameText(nowp,path) then begin
          AddDir(nowp,nil);
          ZIP.SaveToZIP(nowp,nil^,0,clNone);
        end;
        path:=nowp;
      end;
  finally
    TreeView.Items.EndUpdate;
  end;
  TreeView.Items.GetFirstNode.Expand(false);
end;

procedure TMainForm.SetSource(Value: TStream);
begin
  FSource:=Value;
  ZIP.ZipSource:=Value;
  ListView.Clear;
  DirUpdate;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var FileInfo:TSHFileInfo;
    SmallImages,LargeImages:Integer;
    pth:array [0..MAX_PATH-1] of Char;
begin
  ZIP:=TZIP.Create;
  {$IFDEF TESTAPP}
  if not OpenDialog1.Execute then exit;
  FileStream:=TFileStream.Create(OpenDialog1.FileName,fmOpenRead or fmShareDenyNone);
  Source:=FileStream;
  {$ENDIF}
  // Nastaven systmovch ikon
  SmallImages := SHGetFileInfo('C:\', { Do not localize }
    0, FileInfo, SizeOf(FileInfo), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  LargeImages := SHGetFileInfo('C:\', { Do not localize }
    0, FileInfo, SizeOf(FileInfo), SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
  if SmallImages <> 0 then begin
    SendMessage(ListView.Handle, LVM_SETIMAGELIST, LVSIL_SMALL, SmallImages);
    SendMessage(TreeView.Handle, TVM_SETIMAGELIST, TVSIL_NORMAL, SmallImages);
  end;
  if LargeImages <> 0 then begin
    SendMessage(ListView.Handle, LVM_SETIMAGELIST, LVSIL_NORMAL, LargeImages);
  end;
  // zskn indexu ikony sloky
  GetSystemDirectory(@pth,MAX_PATH);
  SHGetFileInfo(@pth,0,FileInfo,SizeOf(FileInfo),SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
  iFolderLarge:=FileInfo.iIcon;
  SHGetFileInfo(@pth,0,FileInfo,SizeOf(FileInfo),SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  iFolderSmall:=FileInfo.iIcon;
  SHGetFileInfo(@pth,0,FileInfo,SizeOf(FileInfo),SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_OPENICON);
  iFolderOpen:=FileInfo.iIcon;
  ListView.ViewStyle:=vsReport;
  // zapnut akceptovn petahovn soubor na ListView
  DragAcceptFiles(Handle,true);
  // vytvoen HexDumpu
  FHexDump:=THexDump.Create(Self);

  FHexDump.Parent:=Panel1;
  FHexDump.Font.Name := 'System';
  FHexDump.Font.Charset:=DEFAULT_CHARSET;
  FHexDUmp.Font.Pitch:=fpFixed;
  FHexDump.Font.Height:=-11;
  FHexDump.CanEdit:=true;
  FHexDump.OnChange:=OnHexChanged;
  NoteBook.ActivePage:='Browser';
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  ZIP.Free;
  FileStream.Free;
end;

//////////////////////////////////////////////////////////
// Aktualizace ListView pi zmn sloky
procedure TMainForm.TreeViewChanging(Sender: TObject; Node: TTreeNode;
  var AllowChange: Boolean);
begin
  if (Node=nil) then exit;
  ListView.Items.BeginUpdate;
  try
    if Node.Data = nil then
      BuildNodeList(Node);
    // musme oznmit, kolik poloek m ListView mt,
    // zbytek informac se zsk pomoc udlosti OnData
    if Node.Data <>nil then
      ListView.Items.Count:=Length(PData(Node.Data)^);
    ListView.Selected := nil;
  finally
    ListView.Items.EndUpdate;
  end;
end;

////////////////////////////////////////////////////////////
// Uvolnn alokovanch dat pro kadou sloku v TreeView
procedure TMainForm.TreeViewDeletion(Sender: TObject; Node: TTreeNode);
begin
  ClearNodeList(Node);
end;

//////////////////////////////////////////////////////////
// zskn indexu ikony podle pro adresovou strukturu
procedure TMainForm.TreeViewGetImageIndex(Sender: TObject; Node: TTreeNode);
var i:Integer;
begin
  with Node do begin
    if Expanded or Selected then
      i:=iFolderOpen
    else
      i:=iFolderSmall;
    ImageIndex:=i;
    SelectedIndex:=i;
  end;
end;

//////////////////////////////////////////////////
// Akce pi kliknut na poloku
procedure TMainForm.ListViewDblClick(Sender: TObject);
var item:TListItem;
    node:TTreeNode;
begin
  with ListView.ScreenToClient(Mouse.CursorPos) do
    item:=ListView.GetItemAt(X,Y);
  node:=TreeView.Selected;
  if (item = nil) or (node =nil) then exit;
  if item.Index<node.Count then
    // poloka je sloka - vstoupme do n
    TreeView.Selected:=node.Item[item.Index]
  else
    // poloka je soubor - provedeme editaci/prohlen
    EditFile(PData(node.Data)^[item.Index]);

end;

/////////////////////////////////////////////////////////
// zskn vech potebnch informac o polokch. Toto
// se vol pro kadou poloku, jejm jedinm platnm
// parametrem je Index.
procedure TMainForm.ListViewData(Sender: TObject; Item: TListItem);
var node:TTreeNode;
    nl:PData;
begin
  node:=TreeView.Selected;
  if node = nil then exit;
  if node.Data = nil then
    BuildNodeList(node);
  nl:=node.Data;
  if Item.Index>High(nl^) then exit;
  with nl^[Item.Index] do begin
    Item.Caption:=Caption;
    if ListView.ViewStyle = vsIcon then
      Item.ImageIndex:=LargeImageIndex
    else
      Item.ImageIndex:=SmallImageIndex;
    if FileHeader <> nil then with FileHeader^ do begin
      Item.SubItems.Add(Format('%d',[UncompressedSize]));
      if UncompressedSize>CompressedSize then
        Item.SubItems.Add(Format('%d %%',[100*(UncompressedSize-CompressedSize)div (UncompressedSize+1)]))
      else
        Item.SubItems.Add('0 %');
      Item.SubItems.Add(Format('%d',[CompressedSize]));
    end;
  end;
end;

////////////////////////////////////////////////////////
// Zmna ViewStyle kliknutm na nkter buton v ToolBaru
procedure TMainForm.btnIconsClick(Sender: TObject);
begin
  ListView.ViewStyle := TViewStyle((Sender as TComponent).Tag);
end;

////////////////////////////////////////////////////////
// posun o jednu rove v
procedure TMainForm.btnBackClick(Sender: TObject);
begin
  with TreeView do
    if (Selected<>nil) and (Selected.Parent<>nil) then
      Selected:=Selected.Parent;
end;

procedure TMainForm.EditFile(const Item: TItem);
begin
  FFileChanged:=false;
  EditedItem:=Item;
  if not InitImageBrowser(Item) then
  if not InitTextEditor(Item) then
  if not InitHexEditor(Item) then;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    btnCloseClick(Self);
  if (NoteBook.ActivePage = 'Browser') and (Key = VK_DELETE) then
    Self.btnDeleteClick(Self);
  if NoteBook.ActivePage = 'ImageEditor' then begin
    Case Key of
      VK_NEXT:
        btnNextImageClick(Self);
      VK_PRIOR:
        btnPrevImageClick(Self);
      VK_SPACE:
        with btnViewOpacity do
          if Enabled then begin
            Down:=not Down;
            Click;
          end;
      VK_RETURN:
        btnCloseClick(Self);
    end;
  end;
end;

function TMainForm.InitImageBrowser(const Item: TItem):Boolean;
const pfToBit:array [TPixelFormat] of Byte =
      (0, 1, 4, 8, 15, 16, 24, 32, 255);
var jim:TJPEGImage;
    tga:TTGAImage;
    str:TStream;
    tp:Integer;
    pf:TPixelFormat;
begin
  tp:=AnsiIndexText(ExtractFileExt(Item.Caption),imageext);
  Result:=tp<>-1;
  if not Result then exit;
  Caption:=Item.Caption;
  str:=ZIP.OpenFile(Item.FileHeader^.FileName);
  Image.Picture.Graphic:=nil;
  Image.Stretch:=not btnImageFit.Down;
  pf:=pfCustom;
  ImageInfo.Panels[1].Text:='';
  try
    btnViewOpacity.Enabled:=false;
    Case tp of
      0: {BMP}
        begin
          Image.Picture.Bitmap.LoadFromStream(str);
          pf:=Image.Picture.Bitmap.PixelFormat;
        end;
      1: {JPEG}
        begin
          jim:=TJPEGImage.Create;
          try
            jim.LoadFromStream(str);
            if jim.PixelFormat = jf24Bit then
              pf:=pf24bit
            else
              pf:=pf8bit;
            Image.Picture.Graphic:=jim;
          finally
            jim.Free;
          end;
        end;
      2: {TGA}
        begin
          tga:=TTGAImage.Create;
          try
            tga.LoadFromStream(str);
            tga.Alfa:=btnViewOpacity.Down;
            pf:=tga.PixelFormat;
            Image.Picture.Graphic:=tga;
            btnViewOpacity.Enabled:= pf = pf32bit;
            with ImageInfo.Panels[1] do
              if tga.Compressed then
                Text:='Komprimovn';
          finally
            tga.Free;
          end;
        end;
    end;
  finally
    str.Free;
  end;
  NoteBook.ActivePage:='ImageEditor';
  with Image.Picture.Graphic do begin
    if btnImageFit.Down then begin
        Self.ClientWidth:=Max(256,Min(Width,Screen.Width-Self.Width+Self.ClientWidth));
        Self.ClientHeight:=Max(256+CoolBar2.Height+ImageInfo.Height,Min(Height+CoolBar2.Height+ImageInfo.Height,Screen.Height-Self.Height+Self.ClientHeight));
        Self.Top:=(Screen.Height-Self.Height) div 2;
        Self.Left:=(Screen.Width-Self.Width) div 2;
    end;
    ImageInfo.Panels[0].Text:=Format('%d x %d x %d',[Width,Height,pfToBit[pf]]);
  end;
end;

///////////////////////////////////////////////////////
// vyhledn a zobrazen nsledujcho obrzku
procedure TMainForm.btnNextImageClick(Sender: TObject);
var i:Integer;
begin
  with ListView do
    for i:=Selected.Index+1 to Items.Count-1 do
      if AnsiIndexText(ExtractFileExt(PData((TreeView.Selected.Data))^[i].Caption),imageext)<>-1 then begin
        Selected:=nil;
        Selected:=Items[i];
        EditFile(PData(TreeView.Selected.Data)^[i]);
        exit;
      end;
end;

///////////////////////////////////////////////////////
// vyhledn a zobrazen pedchzejcho obrzku
procedure TMainForm.btnPrevImageClick(Sender: TObject);
var i:Integer;
begin
  with ListView do
    for i:=Selected.Index-1 downto 0 do
      if AnsiIndexText(ExtractFileExt(PData((TreeView.Selected.Data))^[i].Caption),imageext)<>-1 then begin
        Selected:=nil;
        Selected:=Items[i];
        EditFile(PData(TreeView.Selected.Data)^[i]);
        exit;
      end;
end;

///////////////////////////////////////////////////////////
// Obnova obrzku pi stlaen btnImageFit butonu
procedure TMainForm.btnImageFitClick(Sender: TObject);
begin
  EditFile(PData(TreeView.Selected.Data)^[ListView.Selected.Index]);
end;

/////////////////////////////////////////////////////
// nvrat k Browseru
procedure TMainForm.btnCloseClick(Sender: TObject);
var method:TCompressionLevel;
    p:pointer;
    l:Integer;
begin
  if FFileChanged and
    ((NoteBook.ActivePage = 'TextEditor') or (NoteBook.ActivePage = 'HexEditor')) then
    if MessageBox(Handle,'Uloit zmny?', 'Editace souboru', MB_YESNO)= IDYES then
      with EditedItem.FileHeader^ do begin
        if CompressionMethod=8 then
          Case Flag and 6 of
            0:method:=clDefault;
            6:method:=clFastest;
          else
            method:=clMax;
          end
        else
          method:=clNone;
        with TSelForm.Create(nil) do
          try
            ComboBox1.ItemIndex:=Ord(method);
            if ShowModal = mrOK then
              method:=TCompressionLevel(ComboBox1.ItemIndex);
          finally
            Free;
          end;
        if NoteBook.ActivePage = 'HexEditor' then begin
          p:=FHexDump.Address;
          l:=FHexDump.DataSize;
        end else begin
          p:=PChar(TextEditor.Text);
          l:=TextEditor.GetTextLen;
        end;
        ZIP.SaveToZIP(FileName,p^,l,method);
        FZIPChanged:=true;
        ClearNodeList(TreeView.Selected);
      end;
  NoteBook.ActivePage:='Browser';
end;

///////////////////////////////////////////////////////
// Pepna zobrazen Alfa masky
procedure TMainForm.btnViewOpacityClick(Sender: TObject);
begin
  EditFile(PData(TreeView.Selected.Data)^[ListView.Selected.Index]);
end;

//////////////////////////////////////////////////////
// Oeten pohybu koleka
procedure TMainForm.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  Handled:=true;
  if NoteBook.ActivePage = 'ImageEditor' then
    btnNextImageClick(Self)
  else
    Handled:=false;
end;

procedure TMainForm.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  Handled:=true;
  if NoteBook.ActivePage = 'ImageEditor' then
    btnPrevImageClick(Self)
  else
    Handled:=false;
end;

procedure TMainForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
end;

////////////////////////////////////////////////////////
// zznam a obnova informac o rozmrech Browseru
procedure TMainForm.NotebookPageChanged(Sender: TObject);
begin
  with PosInfo do
    if NoteBook.ActivePage = 'Browser' then begin
      if Stored then begin
        Width:=SWidth;
        Height:=SHeight;
        Top:=STop;
        Left:=SLeft;
        Stored:=false;
      end;
      Caption:=FName;
    end else if not Stored then begin
        SWidth:=Width;
        SHeight:=Height;
        STop:=Top;
        SLeft:=Left;
        Stored:=true;
    end;
end;

function TMainForm.InitTextEditor(const Item: TItem): Boolean;
var str:TStream;
    i:Integer;
    c:Byte;
begin
  Result:=ZIP.FileSize(Item.FileHeader^.FileName)<65000;
  if not Result then exit;
  str:=ZIP.OpenFile(Item.FileHeader^.FileName);
  try
    // proven prvnch 256 znak, e se jedn o ASCII soubor
    for i:=1 to Max(256,{str.Size}200) do begin
      str.Read(c,1);
      Result:=Result and not ((c<32) and (c<>13) and (c<>10) and (c<>9));
    end;
    if not Result then exit;
    str.Position:=0;
    TextEditor.Lines.LoadFromStream(str);
    FFileChanged:=false;
    NoteBook.ActivePage:='TextEditor';
  finally
    ZIP.CloseFile(str);
  end;
end;

function TMainForm.InitHexEditor(const Item: TItem): Boolean;
var str:TStream;
begin
  Result:=true;
  str:=ZIP.OpenFile(Item.FileHeader^.FileName);
  if str = nil then MessageBox(Handle,'Je to na hovno',nil,0);
  try
    FHexDump.AssignStream(str);
    FFileChanged:=false;
    NoteBook.ActivePage:='HexEditor';
  finally
    ZIP.CloseFile(str);
  end;
end;

//////////////////////////////////////////////////////
// Pidn nov sloky do vybran poloky TreeView
procedure TMainForm.btnNewFolderClick(Sender: TObject);
const NFNAME = 'Nov sloka';
var path,newf:string;
    i:Integer;
begin
  if TreeView.Selected = nil then exit;
  path:=GetPathFromNode(TreeView.Selected);
  // 1. zskat nzev nov sloky
  i:=0;
  repeat
    newf:=path + NFNAME;
    if  i>0 then
      newf:=newf+IntToStr(i);
    inc(i);
  until (ZIP.FindHeader(newf+'\')=-1) or (i>100);
  NewDir(newf,TreeView.Selected);
  // 2.oteven vybran poloky, aby byla ihned vidt nov sloka
  TreeView.Selected.Expand(false);
  // 3.refresh ListView
  ListView.Refresh;
  FZIPChanged:=true;
end;

////////////////////////////////////////////////////////////
//  Pejmenovn sloky
procedure TMainForm.TreeViewEdited(Sender: TObject; Node: TTreeNode;
  var S: String);
var i:Integer;
    oldpath,newpath:string;
begin
  if (Node = nil) or (Node.Parent = nil) then exit;
  // musme pejmenovat vechny zznamy v ZIP.Header s touto cestou
  // 1. nalezneme prvn zznam, pro rychlost
  oldpath:=GetPathFromNode(Node);
  newpath:=GetPathFromNode(Node.Parent)+s+'\';
  i:=ZIP.FindHeader(oldpath);
  while (i<>-1) and (i<ZIP.Headers.Count) do
    with PFileHeader(ZIP.Headers[i])^ do begin
      if SameText(LeftStr(FileName,Length(oldpath)),oldpath) then begin
        FileName:=StringReplace(FileName,oldpath,newpath,[rfIgnoreCase]);
        FileNameLength:=Length(FileName);
      end;
      Inc(i);
    end;
  // 2.setdn Headers
  ZIP.Headers.Sort(@ZIPStream.Compare);
  // 3. refresh nodelistu od Node.Parent
  ClearNodeList(Node.Parent);
  FZIPChanged:=true;
end;

//////////////////////////////////////////////////////////
// pejmenovn poloky v ListView
procedure TMainForm.ListViewEdited(Sender: TObject; Item: TListItem;
  var S: String);
var node:TTreeNode;
    buf:pointer;
    count:Cardinal;
    m:TCompressionLevel;
begin
  // pokud se jedn o sloku, volme TreeViewEdited
  node:=TreeView.Selected;
  if (item = nil) or (node =nil) then exit;
  if item.Index<node.Count then
    TreeViewEdited(TreeView,TreeView.Selected,s)
  else with PData(node.Data)^[item.Index].FileHeader^ do begin
  // jinak vyhledme soubor v headers, pokud existuje, stornujeme
    if ZIP.FindHeader(GetPathFromNode(node)+s)<>-1 then begin
      MessageBox(Handle,WARNFILEEXISTS,nil,MB_ICONWARNING);
      exit;
    end;
    ZIP.LoadFile(FileName,buf,count);
    try
      FileName:=GetPathFromNode(node)+s;
      if CompressionMethod = 0 then
        m:=clNone
      else
        m:=clMax;
      ZIP.SaveToZIP(FileName,buf^,count,m);
    finally
      FreeMem(buf);
    end;
    ClearNodeList(Node);
  end;
  FZIPChanged:=true;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SendMessage(ListView.Handle, LVM_SETIMAGELIST, LVSIL_SMALL, 0);
  SendMessage(ListView.Handle, LVM_SETIMAGELIST, LVSIL_NORMAL, 0);
  SendMessage(TreeView.Handle, TVM_SETIMAGELIST, TVSIL_NORMAL, 0);
end;

/////////////////////////////////////////////////////////
// vkldn soubor do ZIPU
procedure TMainForm.AcceptDropFiles(var Message: TMessage);
var comp:TCompressionLevel;
  procedure AddFile(const Name:string;Node:TTreeNode);
  var ms:TMemoryStream;
      sr: TSearchRec;
      rec:string;
  begin
    rec:=GetPathFromNode(Node)+ExtractFileName(Name);
    if FileExists(Name) then begin
      // je to soubor
      ms:=TMemoryStream.Create;
      ms.LoadFromFile(name);
      try
        ZIP.SaveToZIP(rec,ms.Memory^,ms.Size,comp);
      finally
        ms.Free;
      end;
    end else if DirectoryExists(Name) then begin
      // jedn se o sloku - rekurzivn vkldme obsah sloky
      node:=NewDir(rec,Node);
      if FindFirst(Name+'\*.*', faDirectory, sr) = 0 then begin
        repeat
          if (sr.Name = '.') or (sr.Name = '..') then Continue;
          if (sr.Attr and faDirectory) = 0 then
            AddFile(Name+'\'+sr.Name,node)
          else
            AddFile(Format('%s%s%s',[Name,'\',sr.Name]),node);
        until FindNext(sr) <> 0;
        FindClose(sr);
      end;
    end;
  end;
var name:array [0..MAX_PATH-1] of Char;
    i:Integer;
    count:Cardinal;
    a:Boolean;
begin
  count:=DragQueryFile(Message.WParam,$FFFFFFFF,nil,0);
  if count = 0 then exit;
  with TSelForm.Create(nil) do begin
    try
      if ShowModal = mrCancel then exit;
      comp:=TCompressionLevel(ComboBox1.ItemIndex);
    finally
      Free;
    end;
  end;
  for i:=0 to count-1 do begin
    DragQueryFile(Message.WParam,i,@name,Max_PATH);
    AddFile(name,TreeView.Selected);
  end;
  // uvolnn pamti
  DragFinish(Message.WParam);
  // refresh
  ClearNodeList(TreeView.Selected);
  a:=true;
  TreeView.OnChanging(Self,TreeView.Selected,a);
  ListView.Refresh;
  // zmna
  FZIPChanged:=true;
end;

function TMainForm.NewDir(const Name: string; Parent: TTreeNode):TTreeNode;
begin
  // 1. pidat do zipu
  ZIP.SaveToZIP(Name+'\',nil^,0,clNone);
  // 2. pidat do TreeView
  Result:=TreeView.Items.AddChild(Parent,ExtractFileName(Name));
  // 3.sestaven novho nodelistu (resp. jeho donucen)
  ClearNodeList(parent);
  // 4.refresh ListView
  ListView.Refresh;
  // 5.zmna
  FZIPChanged:=true;
end;


procedure TMainForm.FormShow(Sender: TObject);
begin
  Caption:=Fname;
  FZIPChanged:=false;
end;

procedure TMainForm.TextEditorChange(Sender: TObject);
begin
  FFileChanged:=true;
end;

///////////////////////////////////////////////////
// mazn souboru / sloky
procedure TMainForm.btnDeleteClick(Sender: TObject);
var item:TListItem;
    node:TTreeNode;
    i:Integer;
begin
  node:=TreeView.Selected;
  if (node = nil) or not ListView.Focused then exit;
  for i:=ListView.Items.Count-1 downto 0 do begin
    item:=ListView.Items[i];
    if not item.Selected then Continue;
    with PData(node.Data)^[item.Index] do
      if IsFolder then begin
        DeleteFolder(GetPathFromNode(node.Item[i]));
        node.Item[i].Free;
      end else
        ZIP.DeleteFile(FileHeader.FileName);
  end;
  ClearNodeList(node);
  TreeViewChanging(Self,node,PBoolean(nil)^);
  FZIPChanged:=true;
end;

procedure TMainForm.DeleteFolder(const Name: string);
var i:Integer;
begin
  for i:=ZIP.Headers.Count-1 downto 0 do
    with PFileHeader(ZIP.Headers[i])^ do
      if SameText(Name,LeftStr(FileName,Length(Name))) then
        ZIP.DeleteFile(FileName);
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if FZIPChanged then begin
    ModalResult:=MessageBox(Handle,'Uloit zmny ?','Konec',MB_YESNOCANCEL or MB_ICONQUESTION);
    CanClose:= ModalResult <>IDCANCEL;
  end;
end;

procedure TMainForm.OnHexChanged(Sender: TObject);
begin
  FFileChanged:=true;
end;

end.
